
%El siguiente programa resuelve la cinemtica directa completa del robot
%PUMA 560 dado la matriz DH del robot y los parmetros Theta iniciales y 
%finales, as como el tiempo del movimiento y el incremento del mismo.
%Dicho programa tambin representa de forma almbrica el movimiento de
%dicho robot en el espacio.
%------------------------------------------------------------------------

%Primer paso: aadir la matriz con 
%los parmetros de DH y las longitudes de todas las barras del robot.

%  alpha    a    d    theta tipo  xi  yi  zi  xf  yf  zf    R   G   B
PUMA=[ 0      0    0     0     0    0   0   0   0   0 -623.57 1   0   1;
   -pi/2    0    0     0     0    0   0   0   0   0  129.54 0   1   1;
     0    431.8 129.54 0     0    0   0   0 -431.8 0   0    0   0  0.9;
   pi/2  -20.32  0     0     0    0   0   0  20.32 0   0    0   1   0;
  -pi/2     0   432.09 0     0    0   0   0   0 432.09 0   1    0   0;
   pi/2     0    0     0     0    0   0   0   0   0    0  0.5  0.5  0;
     0      0   56.26  0     0    0   0   0   0   0 -56.26 0.4 0.8 0.8];
 %-----------------------------------------------------------------------
 %Segundo paso: llamada de la funcion "nuevagentray" la cual me devolver 
 %el ngulo en radianes de cada uno de los motores del robot,
 %as como la velocidad y aceleracin de cada uno de ellos durante el
 %intervalo de tiempo especificado y para las posiciones deseadas.
 %Esta parte me devolver una matriz de 18 columnas y tantas filas como
 %saltos de incremento de tiempo hayan hasta que se cumpla el tiempo final
 %del movimiento.
 thetasinigrad=[0 0 0 0 0 0];
 thetasfingrad=[25 15 45 0 30 0];
 thetaini=gradrad(thetasinigrad); %robot en posicin con el brazo extendido
 thetafin=gradrad(thetasfingrad);
 tfin=3;
 inct=0.0375;
 [trayvelacel]=nuevagentray(tfin,inct);
 inigraf %inicia el entorno grfico definido
 clc %limpia el entorno
 lineas=crearob(PUMA,thetaini');%dibuja el robot en reposo
 dibrob(PUMA,lineas,trayvelacel,inct);%dibuja el robot efectuando el movimiento deseado
 %-----------------------------------------------------------------------
 %A continuacin se iniciar un bucle for que se repita tanto como tantas
 %filas tenga "trayvelacel" y se aplicar la funcin "jacobcalculo" para
 %resolver la cinemtica directa.
 tamano=size(trayvelacel);
 Cinematicaresultado=[];
 for i=1:tamano(1)
     Cinematicaresultado=[Cinematicaresultado;jacobcalculo(thetaini,...
      trayvelacel(i,7:12),trayvelacel(i,13:18),...
      trayvelacel(i,1:6))];
 end
 Cinematicaresultado;
 %graficador(Cinematicaresultado,1);
 