%Le llega la matriz de DH del robot, la matriz homogenea de posicin y orientacin del efector final,
%el vector de coordenadas de la posicin deseada del efector final y las
%variables theta de las articulaciones en la posicin en la que se encuentra

function matincin=invcinpuma(robot,matriz,thetas)

px=matriz(1,4);
py=matriz(2,4);
pz=matriz(3,4);
nx=matriz(1,1);
ny=matriz(2,1);
nz=matriz(3,1);
sx=matriz(1,2);
sy=matriz(2,2);
sz=matriz(3,2);
ax=matriz(1,3);
ay=matriz(2,3);
az=matriz(3,3);

d2=robot(3,3);
d4=robot(5,3);
d6=robot(7,3);
a2=robot(3,2);
a3=robot(4,2);

pwx=px-d6*ax;
pwy=py-d6*ay;
pwz=pz-d6*az;

lamda=((((pwx*cos(thetas(1)))+(pwy*sin(thetas(1))))^2)+(pwz^2)-(a3^2)-(a2^2)-(d4^2))/(2*a2);

%Posibles variables theta1:
theta1pos=atan2(-pwx,pwy)+atan2(+sqrt(pwy^2+pwx^2-d2^2),d2);
theta1neg=atan2(-pwx,pwy)+atan2(-sqrt(pwy^2+pwx^2-d2^2),d2);

%Posibles variables theta3:
theta3pos=atan2(d4,a3)+atan2(sqrt(a3^2+d4^2-lamda^2),lamda);
theta3neg=atan2(d4,a3)+atan2(-sqrt(a3^2+d4^2-lamda^2),lamda);

%Posibles variables theta2:
theta21=atan2((cos(theta1pos)*pwx+sin(theta1pos)*pwy)*(-a3*sin(theta3pos)+d4*cos(theta3pos))-pwz*(a2+a3*cos(theta3pos)+d4*sin(theta3pos)),(cos(theta1pos)*pwx+sin(theta1pos)*pwy)*(a2+a3*cos(theta3pos)+d4*sin(theta3pos))+pwz*(-a3*sin(theta3pos)+d4*cos(theta3pos)));
theta22=atan2((cos(theta1pos)*pwx+sin(theta1pos)*pwy)*(-a3*sin(theta3neg)+d4*cos(theta3neg))-pwz*(a2+a3*cos(theta3neg)+d4*sin(theta3neg)),(cos(theta1pos)*pwx+sin(theta1pos)*pwy)*(a2+a3*cos(theta3neg)+d4*sin(theta3neg))+pwz*(-a3*sin(theta3neg)+d4*cos(theta3neg)));
theta23=atan2((cos(theta1neg)*pwx+sin(theta1neg)*pwy)*(-a3*sin(theta3pos)+d4*cos(theta3pos))-pwz*(a2+a3*cos(theta3pos)+d4*sin(theta3pos)),(cos(theta1neg)*pwx+sin(theta1neg)*pwy)*(a2+a3*cos(theta3pos)+d4*sin(theta3pos))+pwz*(-a3*sin(theta3pos)+d4*cos(theta3pos)));
theta24=atan2((cos(theta1neg)*pwx+sin(theta1neg)*pwy)*(-a3*sin(theta3neg)+d4*cos(theta3neg))-pwz*(a2+a3*cos(theta3neg)+d4*sin(theta3neg)),(cos(theta1neg)*pwx+sin(theta1neg)*pwy)*(a2+a3*cos(theta3neg)+d4*sin(theta3neg))+pwz*(-a3*sin(theta3neg)+d4*cos(theta3neg)));

%Posibles variables theta4:
theta411=atan2(-sin(theta1pos)*ax+cos(theta1pos)*ay,cos(theta1pos)*cos(theta21)*cos(theta3pos)*ax+sin(theta1pos)*cos(theta21)*cos(theta3pos)*ay-sin(theta21)*sin(theta3pos)*az);
theta421=atan2(sin(theta1pos)*ax-cos(theta1pos)*ay,sin(theta21)*sin(theta3pos)*az-cos(theta1pos)*cos(theta21)*cos(theta3pos)*ax-sin(theta1pos)*cos(theta21)*cos(theta3pos)*ay);
theta412=atan2(-sin(theta1pos)*ax+cos(theta1pos)*ay,cos(theta1pos)*cos(theta22)*cos(theta3neg)*ax+sin(theta1pos)*cos(theta22)*cos(theta3neg)*ay-sin(theta22)*sin(theta3neg)*az);
theta422=atan2(sin(theta1pos)*ax-cos(theta1pos)*ay,sin(theta22)*sin(theta3neg)*az-cos(theta1pos)*cos(theta22)*cos(theta3neg)*ax-sin(theta1pos)*cos(theta22)*cos(theta3neg)*ay);
theta413=atan2(-sin(theta1neg)*ax+cos(theta1neg)*ay,cos(theta1neg)*cos(theta23)*cos(theta3pos)*ax+sin(theta1neg)*cos(theta23)*cos(theta3pos)*ay-sin(theta23)*sin(theta3pos)*az);
theta423=atan2(sin(theta1neg)*ax-cos(theta1neg)*ay,sin(theta23)*sin(theta3pos)*az-cos(theta1neg)*cos(theta23)*cos(theta3pos)*ax-sin(theta1neg)*cos(theta23)*cos(theta3pos)*ay);
theta414=atan2(-sin(theta1neg)*ax+cos(theta1neg)*ay,cos(theta1neg)*cos(theta24)*cos(theta3neg)*ax+sin(theta1neg)*cos(theta24)*cos(theta3neg)*ay-sin(theta24)*sin(theta3neg)*az);
theta424=atan2(sin(theta1neg)*ax-cos(theta1neg)*ay,sin(theta24)*sin(theta3neg)*az-cos(theta1neg)*cos(theta24)*cos(theta3neg)*ax-sin(theta1neg)*cos(theta24)*cos(theta3neg)*ay);

%Posibles variables theta5:
theta51=atan2(sqrt(1-((cos(theta21)*cos(theta3pos)-sin(theta21)*sin(theta3pos))*az+(sin(theta1pos)*cos(theta21)*sin(theta3pos)+sin(theta1pos)*sin(theta21)*sin(theta3pos))*ay+(cos(theta1pos)*cos(theta21)*sin(theta3pos)+cos(theta1pos)*sin(theta21)*cos(theta3pos))*ax)^2),(cos(theta21)*cos(theta3pos)-sin(theta21)*sin(theta3pos))*az+(sin(theta1pos)*cos(theta21)*sin(theta3pos)+sin(theta1pos)*sin(theta21)*sin(theta3pos))*ay+(cos(theta1pos)*cos(theta21)*sin(theta3pos)+cos(theta1pos)*sin(theta21)*cos(theta3pos)*ax));
theta52=atan2(sqrt(1-((cos(theta22)*cos(theta3neg)-sin(theta22)*sin(theta3neg))*az+(sin(theta1pos)*cos(theta22)*sin(theta3neg)+sin(theta1pos)*sin(theta22)*sin(theta3neg))*ay+(cos(theta1pos)*cos(theta22)*sin(theta3neg)+cos(theta1pos)*sin(theta22)*cos(theta3neg))*ax)^2),(cos(theta22)*cos(theta3neg)-sin(theta22)*sin(theta3neg))*az+(sin(theta1pos)*cos(theta22)*sin(theta3neg)+sin(theta1pos)*sin(theta22)*sin(theta3neg))*ay+(cos(theta1pos)*cos(theta22)*sin(theta3neg)+cos(theta1pos)*sin(theta22)*cos(theta3neg)*ax));
%theta53=atan2(sqrt(1-((cos(theta23)*cos(theta3pos)-sin(theta23)*sin(theta3pos))*az+(sin(theta1neg)*cos(theta23)*sin(theta3pos)+sin(theta1neg)*sin(theta23)*sin(theta3pos))*ay+(cos(theta1neg)*cos(theta23)*sin(theta3pos)+cos(theta1neg)*sin(theta23)*cos(theta3pos))*ax)^2),(cos(theta23)*cos(theta3pos)-sin(theta23)*sin(theta3pos))*az+(sin(theta1neg)*cos(theta23)*sin(theta3pos)+sin(theta1neg)*sin(theta23)*sin(theta3pos))*ay+(cos(theta1neg)*cos(theta23)*sin(theta3pos)+cos(theta1neg)*sin(theta23)*cos(theta3pos)*ax));
%theta53=atan2(sqrt((cos(theta1neg)*ay-sin(theta1neg)*ax)^2+((-cos(theta23)*sin(theta3pos)-sin(theta23)*cos(theta3pos))*az+(sin(theta1neg)*cos(theta23)*cos(theta3pos)-sin(theta1neg)*sin(theta23)*sin(theta3pos))*ay+(cos(theta1neg)*cos(theta23)*cos(theta3pos)-cos(theta1neg)*sin(theta23)*sin(theta3pos))*ax)^2),(cos(theta23)*cos(theta3pos)-sin(theta23)*sin(theta3pos))*az+(sin(theta1neg)*cos(theta23)*sin(theta3pos)+sin(theta1neg)*sin(theta23)*cos(theta3pos))*ay+(cos(theta1neg)*cos(theta23)*sin(theta3pos)+cos(theta1neg)*sin(theta23)*cos(theta3pos))*ax);
%theta53=atan2(sqrt((cos(theta1neg)*ay-sin(theta1neg)*ax)^2+(cos(theta1neg)*cos(theta23)*cos(theta3pos)*ax+sin(theta1neg)*cos(theta23)*cos(theta3pos)*ay-sin(theta23)*sin(theta3pos)*az)^2),cos(theta1neg)*sin(theta23)*sin(theta3pos)*ax+sin(theta1neg)*sin(theta23)*sin(theta3pos)*ay+cos(theta23)*cos(theta3pos)*az);
theta53=atan2(sqrt(((cos(theta23)*cos(theta3pos)-sin(theta23)*sin(theta3pos))*sz+(sin(theta1neg)*cos(theta23)*sin(theta3pos)+sin(theta1neg)*sin(theta23)*cos(theta3pos))*sy+(cos(theta1neg)*cos(theta23)*sin(theta3pos)+cos(theta1neg)*sin(theta23)*cos(theta3pos))*sx)^2+((sin(theta23)*sin(theta3pos)-cos(theta23)*cos(theta3pos))*nz+(-sin(theta1neg)*cos(theta23)*sin(theta3pos)-sin(theta1neg)*sin(theta23)*cos(theta3pos))*ny+(-cos(theta1neg)*cos(theta23)*sin(theta3pos)-cos(theta1neg)*sin(theta23)*cos(theta3pos))*nx)^2),(cos(theta23)*cos(theta3pos)-sin(theta23)*sin(theta3pos))*az+(sin(theta1neg)*cos(theta23)*sin(theta3pos)+sin(theta1neg)*sin(theta23)*cos(theta3pos))*ay+(cos(theta1neg)*cos(theta23)*sin(theta3pos)+cos(theta1neg)*sin(theta23)*cos(theta3pos))*ax);
%theta54=atan2(sqrt(1-((cos(theta24)*cos(theta3neg)-sin(theta24)*sin(theta3neg))*az+(sin(theta1neg)*cos(theta24)*sin(theta3neg)+sin(theta1neg)*sin(theta24)*sin(theta3neg))*ay+(cos(theta1neg)*cos(theta24)*sin(theta3neg)+cos(theta1neg)*sin(theta24)*cos(theta3neg))*ax)^2),(cos(theta24)*cos(theta3neg)-sin(theta24)*sin(theta3neg))*az+(sin(theta1neg)*cos(theta24)*sin(theta3neg)+sin(theta1neg)*sin(theta24)*sin(theta3neg))*ay+(cos(theta1neg)*cos(theta24)*sin(theta3neg)+cos(theta1neg)*sin(theta24)*cos(theta3neg)*ax));
%theta54=atan2(sqrt((cos(theta1neg)*ay-sin(theta1neg)*ax)^2+((-cos(theta24)*sin(theta3neg)-sin(theta24)*cos(theta3neg))*az+(sin(theta1neg)*cos(theta24)*cos(theta3neg)-sin(theta1neg)*sin(theta24)*sin(theta3neg))*ay+(cos(theta1neg)*cos(theta24)*cos(theta3neg)-cos(theta1neg)*sin(theta24)*sin(theta3neg))*ax)^2),(cos(theta24)*cos(theta3neg)-sin(theta24)*sin(theta3neg))*az+(sin(theta1neg)*cos(theta24)*sin(theta3neg)+sin(theta1neg)*sin(theta24)*cos(theta3neg))*ay+(cos(theta1neg)*cos(theta24)*sin(theta3neg)+cos(theta1neg)*sin(theta24)*cos(theta3neg))*ax);
%theta54=atan2(sqrt((cos(theta1neg)*ay-sin(theta1neg)*ax)^2+(cos(theta1neg)*cos(theta24)*cos(theta3neg)*ax+sin(theta1neg)*cos(theta24)*cos(theta3neg)*ay-sin(theta24)*sin(theta3neg)*az)^2),cos(theta1neg)*sin(theta24)*sin(theta3neg)*ax+sin(theta1neg)*sin(theta24)*sin(theta3neg)*ay+cos(theta24)*cos(theta3neg)*az);
theta54=atan2(sqrt(((cos(theta24)*cos(theta3neg)-sin(theta24)*sin(theta3neg))*sz+(sin(theta1neg)*cos(theta24)*sin(theta3neg)+sin(theta1neg)*sin(theta24)*cos(theta3neg))*sy+(cos(theta1neg)*cos(theta24)*sin(theta3neg)+cos(theta1neg)*sin(theta24)*cos(theta3neg))*sx)^2+((sin(theta24)*sin(theta3neg)-cos(theta24)*cos(theta3neg))*nz+(-sin(theta1neg)*cos(theta24)*sin(theta3neg)-sin(theta1neg)*sin(theta24)*cos(theta3neg))*ny+(-cos(theta1neg)*cos(theta24)*sin(theta3neg)-cos(theta1neg)*sin(theta24)*cos(theta3neg))*nx)^2),(cos(theta24)*cos(theta3neg)-sin(theta24)*sin(theta3neg))*az+(sin(theta1neg)*cos(theta24)*sin(theta3neg)+sin(theta1neg)*sin(theta24)*cos(theta3neg))*ay+(cos(theta1neg)*cos(theta24)*sin(theta3neg)+cos(theta1neg)*sin(theta24)*cos(theta3neg))*ax);


%Posibles variables theta6:
theta611=atan2((cos(theta21)*cos(theta3pos)-sin(theta21)*sin(theta3pos))*sz+(sin(theta1pos)*cos(theta21)*sin(theta3pos)+sin(theta1pos)*sin(theta21)*cos(theta3pos))*sy+(cos(theta1pos)*cos(theta21)*sin(theta3pos)+cos(theta1pos)*sin(theta21)*cos(theta3pos))*sx,(sin(theta21)*sin(theta3pos)-cos(theta21)*cos(theta3pos))*nz+(-sin(theta1pos)*cos(theta21)*sin(theta3pos)-sin(theta1pos)*sin(theta21)*cos(theta3pos))*ny+(-cos(theta1pos)*cos(theta21)*sin(theta3pos)-cos(theta1pos)*sin(theta21)*cos(theta3pos))*nx);
theta621=atan2(-((cos(theta21)*cos(theta3pos)-sin(theta21)*sin(theta3pos))*sz+(sin(theta1pos)*cos(theta21)*sin(theta3pos)+sin(theta1pos)*sin(theta21)*cos(theta3pos))*sy+(cos(theta1pos)*cos(theta21)*sin(theta3pos)+cos(theta1pos)*sin(theta21)*cos(theta3pos))*sx),-((sin(theta21)*sin(theta3pos)-cos(theta21)*cos(theta3pos))*nz+(-sin(theta1pos)*cos(theta21)*sin(theta3pos)-sin(theta1pos)*sin(theta21)*cos(theta3pos))*ny+(-cos(theta1pos)*cos(theta21)*sin(theta3pos)-cos(theta1pos)*sin(theta21)*cos(theta3pos))*nx));
theta612=atan2((cos(theta22)*cos(theta3neg)-sin(theta22)*sin(theta3neg))*sz+(sin(theta1pos)*cos(theta22)*sin(theta3neg)+sin(theta1pos)*sin(theta22)*cos(theta3neg))*sy+(cos(theta1pos)*cos(theta22)*sin(theta3neg)+cos(theta1pos)*sin(theta22)*cos(theta3neg))*sx,(sin(theta22)*sin(theta3neg)-cos(theta22)*cos(theta3neg))*nz+(-sin(theta1pos)*cos(theta22)*sin(theta3neg)-sin(theta1pos)*sin(theta22)*cos(theta3neg))*ny+(-cos(theta1pos)*cos(theta22)*sin(theta3neg)-cos(theta1pos)*sin(theta22)*cos(theta3neg))*nx);
theta622=atan2(-((cos(theta22)*cos(theta3neg)-sin(theta22)*sin(theta3neg))*sz+(sin(theta1pos)*cos(theta22)*sin(theta3neg)+sin(theta1pos)*sin(theta22)*cos(theta3neg))*sy+(cos(theta1pos)*cos(theta22)*sin(theta3neg)+cos(theta1pos)*sin(theta22)*cos(theta3neg))*sx),-((sin(theta22)*sin(theta3neg)-cos(theta22)*cos(theta3neg))*nz+(-sin(theta1pos)*cos(theta22)*sin(theta3neg)-sin(theta1pos)*sin(theta22)*cos(theta3neg))*ny+(-cos(theta1pos)*cos(theta22)*sin(theta3neg)-cos(theta1pos)*sin(theta22)*cos(theta3neg))*nx));
theta613=atan2((cos(theta23)*cos(theta3pos)-sin(theta23)*sin(theta3pos))*sz+(sin(theta1neg)*cos(theta23)*sin(theta3pos)+sin(theta1neg)*sin(theta23)*cos(theta3pos))*sy+(cos(theta1neg)*cos(theta23)*sin(theta3pos)+cos(theta1neg)*sin(theta23)*cos(theta3pos))*sx,(sin(theta23)*sin(theta3pos)-cos(theta23)*cos(theta3pos))*nz+(-sin(theta1neg)*cos(theta23)*sin(theta3pos)-sin(theta1neg)*sin(theta23)*cos(theta3pos))*ny+(-cos(theta1neg)*cos(theta23)*sin(theta3pos)-cos(theta1neg)*sin(theta23)*cos(theta3pos))*nx);
theta623=atan2(-((cos(theta23)*cos(theta3pos)-sin(theta23)*sin(theta3pos))*sz+(sin(theta1neg)*cos(theta23)*sin(theta3pos)+sin(theta1neg)*sin(theta23)*cos(theta3pos))*sy+(cos(theta1neg)*cos(theta23)*sin(theta3pos)+cos(theta1neg)*sin(theta23)*cos(theta3pos))*sx),-((sin(theta23)*sin(theta3pos)-cos(theta23)*cos(theta3pos))*nz+(-sin(theta1neg)*cos(theta23)*sin(theta3pos)-sin(theta1neg)*sin(theta23)*cos(theta3pos))*ny+(-cos(theta1neg)*cos(theta23)*sin(theta3pos)-cos(theta1neg)*sin(theta23)*cos(theta3pos))*nx));
theta614=atan2((cos(theta24)*cos(theta3neg)-sin(theta24)*sin(theta3neg))*sz+(sin(theta1neg)*cos(theta24)*sin(theta3neg)+sin(theta1neg)*sin(theta24)*cos(theta3neg))*sy+(cos(theta1neg)*cos(theta24)*sin(theta3neg)+cos(theta1neg)*sin(theta24)*cos(theta3neg))*sx,(sin(theta24)*sin(theta3neg)-cos(theta24)*cos(theta3neg))*nz+(-sin(theta1neg)*cos(theta24)*sin(theta3neg)-sin(theta1neg)*sin(theta24)*cos(theta3neg))*ny+(-cos(theta1neg)*cos(theta24)*sin(theta3neg)-cos(theta1neg)*sin(theta24)*cos(theta3neg))*nx);
theta624=atan2(-((cos(theta24)*cos(theta3neg)-sin(theta24)*sin(theta3neg))*sz+(sin(theta1neg)*cos(theta24)*sin(theta3neg)+sin(theta1neg)*sin(theta24)*cos(theta3neg))*sy+(cos(theta1neg)*cos(theta24)*sin(theta3neg)+cos(theta1neg)*sin(theta24)*cos(theta3neg))*sx),-((sin(theta24)*sin(theta3neg)-cos(theta24)*cos(theta3neg))*nz+(-sin(theta1neg)*cos(theta24)*sin(theta3neg)-sin(theta1neg)*sin(theta24)*cos(theta3neg))*ny+(-cos(theta1neg)*cos(theta24)*sin(theta3neg)-cos(theta1neg)*sin(theta24)*cos(theta3neg))*nx));

columna1=[theta1pos;theta21;theta3pos;theta411;theta51;-theta611];
columna2=[theta1pos;theta21;theta3pos;theta421;-theta51;-theta621];
columna3=[theta1pos;theta22;theta3neg;theta422;theta52;-theta612];
columna4=[theta1pos;theta22;theta3neg;theta412;-theta52;-theta622];
columna5=[theta1neg;theta24;theta3neg;theta413;theta54;-theta613];
columna6=[theta1neg;theta24;theta3neg;theta423;-theta54;-theta623];
columna7=[theta1neg;theta23;theta3pos;theta424;theta53;-theta614];
columna8=[theta1neg;theta23;theta3pos;theta414;-theta53;-theta624];

matincin=[columna1,columna2,columna3,columna4,columna5,columna6,columna7,columna8];

end