%Matriz jacobiana mediante metodo de Whitney
function output=jacobcalculo(thetin,velocidades,aceleraciones,thetasfin)

%trabajo en radianes y milimetros
%parametros DH del robot
q=sym('q',[1 6]);
qdh=thetin;
d=[0 129.54 0 432.09 0 56.26];
a=[0 431.8 -20.32 0 0 0];
alfa=[-pi/2 0 pi/2 -pi/2 pi/2 0];
%saco las matrices de transformcin homogenea entre sistemas
%de coordenadas consecutivos
A01 = denavit(q(1), d(1), a(1), alfa(1));
A12 = denavit(q(2), d(2), a(2), alfa(2));
A23 = denavit(q(3), d(3), a(3), alfa(3));
A34 = denavit(q(4), d(4), a(4), alfa(4));
A45 = denavit(q(5), d(5), a(5), alfa(5));
A56 = denavit(q(6), d(6), a(6), alfa(6));
%matriz de transformacin del primer al ultimo sistema:
A06= A01 * A12 * A23 * A34 * A45 * A56;
%saco de las matrices homogeneas las de rotacin
R01 = [A01(1,1) A01(1,2) A01(1,3);A01(2,1) A01(2,2) A01(2,3);A01(3,1) A01(3,2) A01(3,3)];
R12 = [A12(1,1) A12(1,2) A12(1,3);A12(2,1) A12(2,2) A12(2,3);A12(3,1) A12(3,2) A12(3,3)];
R23 = [A23(1,1) A23(1,2) A23(1,3);A23(2,1) A23(2,2) A23(2,3);A23(3,1) A23(3,2) A23(3,3)];
R34 = [A34(1,1) A34(1,2) A34(1,3);A34(2,1) A34(2,2) A34(2,3);A34(3,1) A34(3,2) A34(3,3)];
R45 = [A45(1,1) A45(1,2) A45(1,3);A45(2,1) A45(2,2) A45(2,3);A45(3,1) A45(3,2) A45(3,3)];
R56 = [A56(1,1) A56(1,2) A56(1,3);A56(2,1) A56(2,2) A56(2,3);A56(3,1) A56(3,2) A56(3,3)];
%la parte de debajo de la Jacobiana sera:
z=[0;0;1];
%aplico el metodo de whitney:
JR1=z;
JR2=R01*z;
JR3=R01*R12*z;
JR4=R01*R12*R23*z;
JR5=R01*R12*R23*R34*z;
JR6=R01*R12*R23*R34*R45*z;

%a continuacin saco por diferenciacin la parte de arriba de 
%la jacobiana y monto la matriz
Posicion=[A06(1,4);A06(2,4);A06(3,4)];
Jacobiano=[jacobian(Posicion,q);JR1 JR2 JR3 JR4 JR5 JR6];

%qdh, es el parametro theta, qa es el desplazamiento
%sustituyo y obtengo numericamente la matriz jacobiana:
qa=thetasfin;
qs=(qdh+qa);

PosDenavit=double(subs(A06,q,qs));%mat homogenea de transf
JacobianoDouble=double(subs(Jacobiano,q,qs));

%Meto la velocidad en radianes luego
%multiplico la Jacobiana por las velocidades angulares.
va=velocidades;
VAR= transpose(va);

Vel=JacobianoDouble*VAR;
aa =[aceleraciones];
%a continuacion saco los angulos de euler segun las formulas
xteta=sqrt(A06(3,1)^2+A06(3,2)^2);
yteta=A06(3,3);
tetapos =double(subs(atan2(xteta,yteta),q,qs));
tetaneg =double(subs(atan2(-xteta,yteta),q,qs));
psipos=double(subs(atan2(A06(1,3)/sin(tetapos),-A06(2,3)/sin(tetapos)),q,qs));
psineg=double(subs(atan2(A06(1,3)/sin(tetaneg),-A06(2,3)/sin(tetaneg)),q,qs));
phipos=double(subs(atan2(A06(3,1)/sin(tetapos),A06(3,2)/sin(tetapos)),q,qs));
phineg=double(subs(atan2(A06(3,1)/sin(tetaneg),A06(3,2)/sin(tetaneg)),q,qs));
% Primero saco la derivada de la matriz jacobiana(jacopunto)
jacopunto= diff(Jacobiano,q(1),1)*va(1)+ diff(Jacobiano,q(2),1)*va(2)+diff(Jacobiano,q(3),1)*va(3)+diff(Jacobiano,q(4),1)*va(4)+diff(Jacobiano,q(5),1)*va(5)+diff(Jacobiano,q(6),1)*va(6);
%a continuacion saco las aceleraciones:
Acel = double(subs(jacopunto,q,qs))*transpose(va)+double(subs(Jacobiano,q,qs))*transpose(aa);

output=[PosDenavit(1,4),PosDenavit(2,4),PosDenavit(3,4),tetapos,psipos,...
    phipos,tetaneg,psineg,phineg,Vel(1),Vel(2),Vel(3),Vel(4),Vel(5),Vel(6),...
    Acel(1),Acel(2),Acel(3),Acel(4),Acel(5),Acel(6)];
end